////////////////////////////////////////////////////////////////////////////////
//
// Fracter - A simple Mandelbrot Set viewer.
//
// Copyright (C) 2010 Sarah Eris Horsley Caffee
//
// This file is part of Fracter.
//
// Fracter is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Mandelbrot.h
// Mandelbrot set calculator class definition
//
////////////////////////////////////////////////////////////////////////////////

#ifndef MANDELBROT_H
#define MANDELBROT_H

#include <iostream>

#include "Fractal.h"

////////////////////////////////////////////////////////////////////////////////
class ViewMandelbrot : public View
   {
   public:
   ViewMandelbrot(std::string t, 
		  double re, double im, double s, 
		  unsigned int max);

   private:
   friend class Mandelbrot;

   };

////////////////////////////////////////////////////////////////////////////////
class Mandelbrot : public Fractal
   {
   public:
   Mandelbrot();

   bool calc_set();

   ViewMandelbrot * save_view();
   void restore_view(View * v);

   private:

   };

////////////////////////////////////////////////////////////////////////////////
namespace
   {
   class MandelbrotFactory : public FractalFactory
      {
      public:
      MandelbrotFactory()
	 {
	 get_Fractal_map()[typeid(Mandelbrot).name()]=this;
	 }

      Fractal * create() const
	 {
	 return new Mandelbrot;
	 }
      } the_Mandelbrot_factory;
   }

#endif
